//////////////////////////////////////////////////////////////////////
//
//   Autointerlace Free - 25 June 2011
//   by Kohan "SyneRyder" Ikin
//   www.namesuppressed.com/syneryder
//   syneryder@namesuppressed.com
//
//   Simple interlacing effects plugin
//
//   Credits
//   Copyright 2011 namesuppressed.  All rights reserved.
//
//////////////////////////////////////////////////////////////////////

//#include "components/filtermeister/FW_CTL_to_C.h"
//AboutMessage { return "My about screen message goes here."; }
//CtlDef { return TRUE; }
//#include "components/filtermeister/FW_FFP_to_C.h"
//OnCtl(n) { return TRUE; }
//OnWindowStart { return TRUE; }
//OnFilterStart { return TRUE; }
//ForEveryTile { return TRUE; }
//OnFilterEnd { return TRUE; }
//OnFilterExit { return; }





// To compile with a dialog skin and non-resizable window add DIALOGSKIN 
// under Photoshop Plugin > Properties > C/C++ > Preprocessor > Preprocessor definitions
// and Photoshop Plugin > Properties > Resources > General > Preprocessor definitions

// Translate FilterMeister language expressions to C
// This needs to go before CtlDef, to redefine RGB.
#include "components/filtermeister/FW_CTL_to_C.h"



#define plugInVendorName	"namesuppressed" // This is the category
#define plugInAETEComment	"Autointerlace Free Photoshop Plugin"
#define plugInSuiteID		'Autointerlace Free'
#define plugInClassID		plugInSuiteID
#define plugInEventID		plugInClassID
#define plugInCopyrightYear "2011"
#define plugInDescription   "Autointerlace Free"
#define plugInVersion       "1.30"

// Plugin Name ---------------------------------------------------------
#define plugInName	"Autointerlace Free"
#define plugInNameEllipsis "..."
#define plugInUniqueID  "namesuppressed Autointerlace Free" //For actions recording

// Image Modes and Enable Info -----------------------------------------
#define plugInSupportedModes noBitmap, noGrayScale, noIndexedColor, \
                             doesSupportRGBColor, noCMYKColor, \
                             noHSLColor, noHSBColor, noMultichannel, \
                             noDuotone, noLABColor
#define plugInEnableInfo "in (PSHOP_ImageMode, RGBMode, RGB48Mode)"

// About Screen Message and Version Numbers ----------------------------
char * AboutMessage(void) {
//EXTERNC char * AboutMessage(void) {
	#if _WIN64
		return "\n\n\n\nVersion " plugInVersion " (64-bit)";
	#else
		return "\n\n\n\nVersion " plugInVersion " (32-bit)";
	#endif
}











//******************************************************************
//  Global Variables (mostly constants)
//******************************************************************

// Controls (values < 250)
const int CTL_SCANOPACITY = 2;
const int CTL_SCANWIDTH   = 3;

// Common Controls (values < 130)
const int CTL_PROGRESSIMG = 43;
const int CTL_URLBUTTON   = 49;
const int CTL_PROGRESSBAR = 72;
const int CTL_ZOOMIN      = 74;
const int CTL_ZOOMOUT     = 75;
const int CTL_ZOOMCOMBO   = 76;




//******************************************************************
// Control Definitions (Runs only once, before filter dialog shows)
//******************************************************************

CtlDef { 

    // Do we need T-buffers? Only allocate if needed
	need_tbuf = false;
	need_t2buf = false;
	need_t3buf = false;
	need_t4buf = false;


    //**************************************************************
    //  Dialog
    //**************************************************************
    
	// Set Title
	dialogtitle(plugInName)

		dialogtheme(1)
#if DIALOGSKIN
		dialogsize(414, 210)
		dialogminmax(414, 210, 414, 210) //prevents dialog resizing
		dialogcolor(RGB(0, 0, 102))
		dialogimage("autointerlace-free-background.bmp")
		dialogimagemode(DIM_STRETCHED, 0) // I think this stretches the bitmap?
		dragbackground
		notitlebar
		noctlscaling        //Prevents that all controls are scaled to the window size
#else
		dialogcolor(0xe0e0e0)
		dialogsize(414, 222)
		dialogminmax(414, 222, 0, 0)
		maxbox
		sizegrip
#endif		

		PosClientCENTER

		//Embedded Resources -> Moved to FilterResources.rc
		//Embed:  Bitmap="autointerlace-free-background.bmp"
		//Embed:  Bitmap="newurloff.bmp"
		//Embed:  Bitmap="newurlon.bmp"
		//Embed:  Bitmap="progress0.bmp"
		//Embed:  Bitmap="progress02.bmp"
		//Embed:  Bitmap="progress20.bmp"
		//Embed:  Bitmap="progress40.bmp"
		//Embed:  Bitmap="progress60.bmp"
		//Embed:  Bitmap="progress80.bmp"
		//Embed:  Bitmap="progress100.bmp"


    //**********************************************************
    //  Controls
    //**********************************************************

    //ctl(CTL_OK) pushbutton() actionapply() text("OK") pos(359, 205) size(50, 12)
    createCtl(CTL_OK, CC_PUSHBUTTON, "OK", 359, 205, 50, 12, BS_PUSHBUTTON, 0, 0, 3);
    setCtlAction(CTL_OK, CA_APPLY);
    #ifndef DIALOGSKIN
      //anchor(ANCHOR_RIGHT|ANCHOR_BOTTOM)
      setCtlAnchor(CTL_OK, ANCHOR_RIGHT | ANCHOR_BOTTOM)
    #endif

	ctl(CTL_CANCEL) pushbutton() actioncancel() text("Cancel") pos(300,205) size(50,12)
    #ifndef DIALOGSKIN
      anchor(ANCHOR_RIGHT|ANCHOR_BOTTOM)
    #endif
	
	// Trying to modify the default size of the preview
	//ctl(CTL_PREVIEW) pos(5,5) size(229,196)
	setCtlPos(CTL_PREVIEW, 5, 5, 229, 196);

    // Trying to remove / delete standard controls
    ctl(CTL_EDIT) invisible()
    ctl(CTL_LOGO) invisible()
    ctl(CTL_ZOOM) invisible()
    #if DIALOGSKIN
       ctl(CTL_PROGRESS) invisible()
    #endif
    ctl(CTL_FRAME) invisible()

    ctl(CTL_SCANOPACITY) standard() 
        #if DIALOGSKIN
           text("") color(RGB(0,0,102)) textcolor(RGB(255,255,255))
        #else
           text("Distance") 
        #endif
        pos(284,57) range(0,100) val(25) defval(25) actionpreview() scripting(true)

    ctl(CTL_SCANWIDTH)   standard() 
        #if DIALOGSKIN
           text("") color(RGB(0,0,102)) textcolor(RGB(255,255,255))
        #else
           text("Width") 
        #endif
        pos(284,77) range(1,100) val(2) defval(2) actionpreview() scripting(true)

    #if DIALOGSKIN
       ctl(CTL_PROGRESSIMG) bitmap() centerimage() tooltip("Progress Bar") actionnone() pos(5,205) size(169,13) color(RGB(0,0,102)) anchor(ANCHOR_LEFT|ANCHOR_BOTTOM)
       ctl(CTL_URLBUTTON)   imagectl() mouseover() notify() tooltip("Visit namesuppressed online") pos(335,0) size(78,16) actionnone() anchor(ANCHOR_LEFT|ANCHOR_BOTTOM)
    #else
       ctl(CTL_PROGRESS) pos(5,205) size(169,13) 
    #endif
    
    ctl(CTL_ZOOMIN)      pushbutton() text("+") actionnone() size(11,13) pos(179,205) anchor(ANCHOR_LEFT|ANCHOR_BOTTOM) scripting(false)
    ctl(CTL_ZOOMCOMBO)   combobox() 
        text("3200%\n1600%\n1200%\n800%\n700%\n600%\n500%\n400%\n300%\n200%\n---------------\n100%\n50%\n33%\n25%\n20%\n16%\n14%\n12%\n11%\n10%\n9%\n8%\n7%\n6%\n---------------\nFit")
        val(26) defval(26) actionnone() size(33,120) pos(190,205) anchor(ANCHOR_LEFT|ANCHOR_BOTTOM) scripting(false)
    ctl(CTL_ZOOMOUT)     pushbutton() text("-") actionnone() size(11,13) pos(223,205) anchor(ANCHOR_LEFT|ANCHOR_BOTTOM) scripting(false)


	return true;
}





// This needs to go here (after CtlDef, before everything else)
// in order to redefine CTL, val, INVALID_HANDLE_VALUE and NULL.
// Translate FilterMeister language expressions to C
#include "components/filtermeister/FW_FFP_to_C.h"



//******************************************************************
//  Window Start Handler (executed only once after CtlDef)
//******************************************************************

OnWindowStart {

   
#if DIALOGSKIN

   // Set initial images for URL & Progress images
   setCtlImage(CTL_URLBUTTON, "newurloff.bmp",'B');
   setCtlImage(CTL_PROGRESSIMG, "progress0.bmp", 'B');

#endif

  return true;

}



//******************************************************************
// Control Handlers (executed for UI events)
//******************************************************************

OnCtl(n) {

	if (e == FME_EXITSIZE) {
		if (doingProxy && ctl(CTL_ZOOMCOMBO)==26) {
			setZoom(-888, 1);
		 }
	}

  //////////////////////////////////////////////////////////////
  ///  Keypress Intercept
  //////////////////////////////////////////////////////////////

    if (e == FME_KEYDOWN){
	    if (n == VK_ADD){
            if (getAsyncKeyStateF(VK_CONTROL) <= -32767) {
			    triggerEvent(CTL_ZOOMIN, FME_CLICKED,0);
			    return true;
		    }
        } else if (n == VK_SUBTRACT) {
		    if (getAsyncKeyStateF(VK_CONTROL) <= -32767) {
			    triggerEvent(CTL_ZOOMOUT, FME_CLICKED,0);
			    return true;
		    }
        }
    }

  //////////////////////////////////////////////////////////////
  ///  Zoom Control Handlers
  //////////////////////////////////////////////////////////////
  
    if (n == CTL_ZOOMCOMBO) {			

	  return evalZoomCombo(n, CTL_ZOOMIN, CTL_ZOOMOUT, previous);

	} else if ((n == CTL_ZOOMIN || n==CTL_ZOOMOUT) ) {
		
      return evalZoomButtons(n, CTL_ZOOMCOMBO, CTL_ZOOMIN, CTL_ZOOMOUT);

    }

  //////////////////////////////////////////////////////////////
  ///  URL Button Handler
  //////////////////////////////////////////////////////////////

  if (n == CTL_URLBUTTON) {
    int errorcode;
    lockWindow(1);
    switch (e) {
      case FME_MOUSEOVER:
        setCtlImage(CTL_URLBUTTON, "newurlon.bmp",'B');
        break;
      case FME_MOUSEOUT:
        setCtlImage(CTL_URLBUTTON, "newurloff.bmp",'B');
        break;
      case FME_CLICKED:
        strcpy(str9, "http://www.namesuppressed.com/");
        errorcode = shellExec("open", str9, NULL, NULL);
        if (errorcode != -1) {
          msgBox(MB_ICONWARNING | MB_OK,
            "Sorry...",
            "I was unable to establish a connection to the\n"
            "namesuppressed website. Are you sure you're\n"
            "currently connected to the Internet?");
        }
        setCtlImage(CTL_URLBUTTON, "newurloff.bmp",'B');
        break;
    }
    lockWindow(0);
  }

  return false;
}



//*******************************************************************
// Filter Start Handler (Executed before ForEveryTile for every
// preview update and the final rendering)
//******************************************************************

OnFilterStart {
  return true;
}



//******************************************************************
// Self declared function -> Do not use the names of FFP/FML
// functions to avoid problems
//******************************************************************

BOOL fn_ProcessRow(int y, int scanwidth){
    
    return ((y / scanwidth) % 2 == 1);
}



//******************************************************************
// Filter Rendering with multilple threads (Executed from
// ForEveryTile with doMultiThreading())
//******************************************************************

DWORD WINAPI threadProc(LPVOID cpu){

    FMcontext * const fmc = gFmcp; //Make FFP/FML expressions work

    int currentcpu = (int)(INT_PTR)cpu;
    int syncnr = 0;


    int x,y,r,g,b;
    
    int scanwidth = ctl(CTL_SCANWIDTH)/scaleFactor;
    if (scanwidth < 1) scanwidth = 1;

    //*******************************************************************
    //Scanlines
    //*******************************************************************

    //for (y = y_start; y < y_end; y++) {
    for (y = y_start + currentcpu; y < y_end; y += mt.totalcpu) { //Each core renders its own row

        if (fn_ProcessRow(y,scanwidth)) { //Lets try a self declared function

            for (x = x_start; x < x_end; x++) {
                r = pget(x, y, 0);
                g = pget(x, y, 1);
                b = pget(x, y, 2);
                pset(x, y, 0, r * (100 - ctl(CTL_SCANOPACITY)) / 100);
                pset(x, y, 1, g * (100 - ctl(CTL_SCANOPACITY)) / 100);
                pset(x, y, 2, b * (100 - ctl(CTL_SCANOPACITY)) / 100);
            }
        }

        // Update Progress status
        if (currentcpu==0){ //updateProgress() is not ready for multithreading so only call it by one core
            updateProgress(y - y_start, y_end - y_start);
            #if DIALOGSKIN
                if (y == 1)           { setCtlImage(CTL_PROGRESSIMG, "progress02.bmp", 'B'); sleep(50); }
                if (y == (1*y_end)/5) { setCtlImage(CTL_PROGRESSIMG, "progress20.bmp", 'B'); sleep(50); }
                if (y == (2*y_end)/5) { setCtlImage(CTL_PROGRESSIMG, "progress40.bmp", 'B'); sleep(50); }
                if (y == (3*y_end)/5) { setCtlImage(CTL_PROGRESSIMG, "progress60.bmp", 'B'); sleep(50); }
                if (y == (4*y_end)/5) { setCtlImage(CTL_PROGRESSIMG, "progress80.bmp", 'B'); sleep(50); }
            #endif
        }
    }

    waitForSync(syncnr++,INFINITE); //Only needed if another image loop follows below -> Avoids image artifacts by synchronizing the cores


  #if DIALOGSKIN
     if (currentcpu==0){  
         setCtlImage(CTL_PROGRESSIMG, "progress100.bmp", 'B');
         sleep(200);
     }
  #endif
       
    return true;	

}


//*******************************************************************
// ForEveryTile Handler (executed for every preview update and the final rendering)
//*******************************************************************

ForEveryTile {

    //Do any memory or array allocation here and not in threadProc();
    //...
  
    if (ctl(CTL_SCANOPACITY) > 0) {
        doMultiThreading(threadProc, true, true); //Last "true" only needed for synchronizing
    }

    //Free memory or arrays here ...
    //...

    return true;

}




//******************************************************************
// OnFilterEnd Handler (Executed after ForEveryTile for every preview
// update and the final rendering)
//******************************************************************

OnFilterEnd {
	// Reset controls
	updateProgress(0, 100);      // Reset the progress bar.
	setCtlImage(CTL_PROGRESSIMG, "progress0.bmp", 'B');
	return false;
}



//******************************************************************
// OnFilterExit Handler (Executed after Cancel or after full rendering with OK)
//******************************************************************

OnFilterExit {
	return;
}

